#ifndef SURFLOAD_H
#define SURFLOAD_H

#include "../../GEFEL/siftop.h"
#include "../SRC/alias.h"
#include <stdio.h>

/**
  This class is used for surface load in the mechprep preprocessor.
  The surface load is defined on the surface generated by a mesh generator and
  it can be defined in the global or local coordinate system of the given surface.
*/
class surfload
{
  public :
   surfload();
   ~surfload();
   long read(FILE *in, long lc);

   long ndir; ///< number of load directions
   long nlc;  ///< load case number
   long lgcs; ///< global(1)/local(2) coordinate system indicator
   double *f; ///< array with load values  
};

#endif
