#ifndef CONTACTMAT_H
#define CONTACTMAT_H

#include "alias.h"
#include "iotools.h"
struct matrix;
struct vector;
struct atsel;

/**
   class contactmat defines material for contact problems
   
   JK, 11.6.2006
*/

class contactmat
{
 public:
  contactmat (void);
  ~contactmat (void);
  void read (XFILE *in);

  void matstiff (matrix &d,long ipp);

  void nlstresses (long ipp);
  void changeparam (atsel &atm,vector &val);
  
  ///  stiffness along slip
  double slip;
  ///  stiffness orthogonal to slip
  double normal;
  ///  limit force in slip direction
  double limits;
  ///  limit force in normal direction
  double limitn;

};

#endif
