#ifndef ELEMSWITCH_H
#define ELEMSWITCH_H

#include "alias.h"
#include "vector.h"
#include "matrix.h"

void compute_ipstrains (long lcid);
void compute_nodestrains (long lcid);
void computestrains (long lcid);

void compute_ipstresses (long lcid);
void compute_nodestresses (long lcid);
void computestresses (long lcid);

void compute_nodeothers (long lcid);

void elem_intpointval (long eid,vector &nodval,vector &ipval);
void intpointval (double *gv,nonmechquant nmq,double scale);
void intpointval2 (double *gv,nonmechquant nmq);

double interpolate (long eid,double *nodval,double *coord);
void ipvolume ();

void elem_internal_forces (long i,long lcid,vector &ifor);
void elem_local_values (long i,long lcid);
void elem_nonloc_internal_forces (long i,long lcid,vector &ifor);
void elem_incr_internal_forces (long i,long lcid,vector &ifor);
void elem_eigstrain_forces (long lcid,long eid,vector &nfor);


void stiffmat (long lcid,long eid,matrix &sm);
void massmat (long lcid,long eid,matrix &mm);
void initstiffmat (long lcid,long eid,matrix &sm);
void loadmat (long eid,matrix &lm);


#endif
