#ifndef LOADEL_H
#define LOADEL_H

#include <stdio.h>
#include "iotools.h"
#include "alias.h"
#include "vector.h"

/**
   class deals with loads defined on elements
   it contains edge load, surface load and volume load
*/
class loadel
{
 public:
  loadel();
  ~loadel();
  long read(XFILE *in);
  void readvolumeload (XFILE *in);
  void readedgeload (XFILE *in);
  void readsurfaceload (XFILE *in);
  long read_prop(FILE *in, long nne, long lc);
  void volumeload ();
  void edgeload ();
  void surfaceload ();
  
  
  ///  number of loaded element (element id)
  long eid;
  ///  number of DOFs on element
  long ndofe;
  ///  type of element load
  elloadtype tel;
  ///  number of edges
  long ned;
  ///  number of nodes on one edge
  long nned;
  ///  number of surfaces
  long nsurf;
  ///  number of nodes on one surface
  long nnsurf;
  ///  number of approximated functions on element
  long napfun;
  ///  components of edge load
  double *nodval;
  ///  components of surface load
  double *nodvals;
  ///  components of load %vector - nodal forces
  vector nf;
  ///  indicators of loaded edges
  long *le;
  ///  indicators of loaded surfaces
  long *ls;

  long nlc,ndl;
};

#endif
