#ifndef MECHBCLC_H
#define MECHBCLC_H

#include "iotools.h"
class inicd;
class loadcase;
class dloadcase;

/**
   class mechbclc
   
   it is one of the 5 most important classes of the program
   (probdesc, mechtop, mechmat, mechbclc, mechcrsec)
   
   class mechbclc contains data about boundary conditions, load cases
   
   JK, TK
*/

class mechbclc
{
 public:
  mechbclc ();
  ~mechbclc ();
  void read (XFILE *in);
  long readinic (XFILE *in);
  void inicipval(void);
  void alloc_sumcomp ();
  void comp_sum (double *rhs);
  void give_comp_sum (double *sum);

  /// number of load cases
  long nlc;
  /// number of initcond
  long nico;
  
  ///  number of components of array sumcomp
  long ncsum;
  ///  array containing sums of components of load %vector in particular directions 
  double *sumcomp;
  
  loadcase  *lc;
  dloadcase *dlc;
  inicd     *ico;
};

#endif
