#ifndef NSSOLVER_H
#define NSSOLVER_H

#include <stdio.h>

void solve_nonlinear_statics ();

void nonlinear_solver (long lcid);
void print_output(long idlc);

long arclength (long lcid,long adaptcontrol);
long arclength15 (long lcid);
void newton_raphson (long lcid);
void displ_control (long lcid);
double displ_controlrv (long lcid, double inilambda, double dmplambda, double rlambda, double errl, long incrdispl);
void refresh_plast ();
void nonlinear_solver_adaptiv (long lcid);

void aux_nonlin_print (FILE *aux,double *r,double l);
void seldofinit ();
double displincr (double *displincr,long n);
double loadincr (double *loadincr,long n);
void quadeqcoeff (double *ddr,double *v,long n,double ddlambda,double psi,double norfp,double dl,
		  double &a0,double &a1,double &a2);
void arclsave (long fi,long n,double blambda,double dl,double *r,double *fp);

void arclopen (long &fi,long &n,double &blambda,double &dl,double *r,double *fp);

void arclsave_adapt (long fi,double lambda,double dlambda,double dl);
void arclopen_adapt (long &fi,double &lambda,double &dlambda,double &dl);
void newmeshgen (int w,long i);

long arclengthadapt (long lcid,long adaptcontrol);

void newton_raphson_restart (long lcid);

#endif
