#ifndef TIMESWMAT_H
#define TIMESWMAT_H

#include "iotools.h"
#include "alias.h"
struct matrix;
struct vector;
class  gfunct;

/**
  This class defines artificial material model which combines
  several arbitrary material models for time dependent problems
  These models are switched on and off depending on their time functions.
  
  
  15.1.2004
*/
class timeswmat
{
 public:
  timeswmat (void);
  ~timeswmat (void);
  void read(XFILE* in);
  double give_actual_ym(long ipp, long im, long ido);
  double give_initial_ym(long ipp, long im, long ido);
  double give_actual_nu(long ipp, long im, long ido);
  double give_actual_ft(long ipp, long im, long ido);
  long givencompother (long ipp, long im);
  long givencompeqother (long ipp, long im);
  void initvalues(long ipp, long im, long ido);
  void matstiff (matrix &d,long ipp, long im, long ido);
  void nlstresses (long ipp, long im, long ido);
  void updateval (long ipp, long im, long ido);

  /// number of combined material models
  long ncm;
  ///  time functions for material switching
  gfunct *gf;
  
  
};

#endif
